public class Steganography {

    /* Returns a char that is identical to color, except
     * the last bit is value. */
    private char setLastBit(char color, int value) {
        throw new NotImplementedException("setLastBit is not implemented.");
    }

    /* Returns the ith bit of c.  Note that we number
     * from the right.  So, i=0 returns the right-most
     * (i.e. least-significant) bit. */
    private char getBit(char c, int i) {
        /* For each bit in the number, remove the last bit,
         * and shift everything over by one until we get
         * to the bit we're interested in.  For example,
         * if c = (173)_10 = (10101101)_2, and i = 3,
         * here's what happens:
         * The entire number is odd, so we subtract 1,
         * and divide by two: 
         *   ((173)_10 - 1)/2 = (86)_10 = (01010110)_2
         * This time, it's not odd, so we just divide by 2:
         *   ((86)_10)/2 = (43)_10 = (00101011)_2
         * This time it is odd, so we return 1. */
        throw new NotImplementedException("getBit is not implemented.");
    }

    /* Converts a String to an array of bits.  The array of bits
     * always lists each character from least to most significant bits. */
    private char[] convertStringToBits(String s) {
        char[] textAsBits = new char[s.length() * 8];
        int index = 0;

        /* First, convert the string to a character array. */

        /* Then, for each character, get each bit and put
         * it in the textAsBits array. */

        /* Make sure to get the least significant bit first,
         * and go toward the most significant bit. */
        
        throw new NotImplementedException("convertStringToBits is not implemented.");
    }

    /* Converts an array of bits into a String */
    private String convertBitsToString(char[] bits) {
        String output = "";
        char currentBit = 0;
        int placeOfBit = 0;

        /* We know every eight bits makes a single letter.
         * So, combine those eight bits into a single letter
         * by using the definition of binary. */
        
        /* Remember, we're going to get the LEAST significant bit
         * first, because of how convertStringToBits works! */

        /* If the first eight bits we get are 0--1--0--1--1--0--1--1,
         * then we can construct the correct number by doing:
         * 0*2^0 + 1*2^1 + 0*2^2 + 1*2^3 + 1*2^4 + 0*2^5 + 1*2^6 + 1*2^7 */

        /* Then, once we have the numerical value, we can use Character.toString
         * to get the letter, and add it to our output. */
        
        throw new NotImplementedException("convertBitsToString is not implemented.");
    }

    /* Returns a new image that is a copy of image, except it uses the least
     * significant bits of each pixel to hide textToHide inside the image. */
    public PPMImage hidePhraseInImage(PPMImage image, String textToHide) {
        /* Copies the image we're given; so, that the original image is unchanged. */
        PPMImage img = new PPMImage(image); 

        /* Convert the string to bits, and replace every pixel with a version with
         * part of the text hidden. :) */

        throw new NotImplementedException("hidePhraseInImage is not implemented.");
    }

    /* Given an image which has hidden text in it (presumably by using hidePhraseInImage),
     * this method extracts the hidden text from the image. */
    public String getPhraseFromImage(PPMImage image) {
        /* Initialize a new array to store the bits we extract from the image. */
        char[] hiddenBits = new char[(image.getWidth() * image.getHeight()) * 3];

        /* Extract the bits from the image. */
        
        /* Return a String representation of the bits we extracted. */
        
        throw new NotImplementedException("getPhraseFromImage is not implemented.");
    }

    public static void main(String[] args) {
        String textToHide = "This is the phrase to hide :)";
        String fileNameToHide = "monty_hall";

        Steganography stego = new Steganography();

        /* Read in a ppm image to hide something in. */
        PPMImage img = PPMImage.readPNG(fileNameToHide + ".png");

        /* Hide the phrase in the image. */
        PPMImage imgWithString = stego.hidePhraseInImage(img, textToHide);
        imgWithString.writePPM(fileNameToHide + ".hidden.ppm");

        /* Read the image we hid something in back in (to make sure PPMImage is working). */
        PPMImage imgWithHidden = PPMImage.readPPM(fileNameToHide + ".hidden.ppm");
        if (imgWithHidden == null) {
            System.out.println("Uh oh!  We couldn't read in the image we wrote.\n");
            System.exit(1);
        }

        /* Write out a png; so, you can see the image looks identical. */
        if (!imgWithHidden.writePNG(fileNameToHide + ".hidden.png")) {
            System.out.println("Uh oh!  We couldn't write out the png with the hidden text.\n");
            System.exit(1);
        }

        /* Print out the text we extracted. */
        String extractedText = stego.getPhraseFromImage(imgWithString);
        System.out.printf("The secret was: %s\n", extractedText);

        assert(textToHide.equals(extractedText));
    }
}
